Debian Bug report logs - #147091
gdm isn't affected by global LANG set by `locales' package

version graph

Package: gdm; Maintainer for gdm is Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>;

Reported by: Ognyan Kulev <ogi@fmi.uni-sofia.bg>

Date: Wed, 15 May 2002 17:33:03 UTC

Severity: normal

Merged with 133578, 192143, 200064

Found in versions 2.2.5.4-2, 2.2.5.5-2, 2.4.1.7-1, 2.4.1.3-2

Fixed in version gdm/2.4.4.7-2

Done: Ryan Murray <rmurray@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>, gdm@packages.qa.debian.org:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to Ognyan Kulev <ogi@fmi.uni-sofia.bg>:
New Bug report received and forwarded. Copy sent to Ryan Murray <rmurray@debian.org>, gdm@packages.qa.debian.org. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Ognyan Kulev <ogi@fmi.uni-sofia.bg>
To: submit@bugs.debian.org
Subject: gdm isn't affected by global LANG set by `locales' package
Date: Wed, 15 May 2002 23:28:55 +0300
Package: gdm
Version: 2.2.5.5-2

I setup my Debian system (and X) for using Bulgarian language, which 
uses windows-1251 encoding (*-microsoft-cp1251 in X), including 
generating bg_BG data with package `locales'.  With `gdmconfig' I 
configured various stuff, like default language and greeting font.

Here the fun begins.  When I restart the computer the font of the menus 
is with iso8859-1 encoding for the microsoft-cp1251 encoded characters. 
 When gdm is restarted from the console (where LANG=bg_BG is set), 
everything is OK.

The conclusion: when gdm process is started, LANG environment variable 
_must_ be set to the value taken from `/etc/environment' where `locales' 
package put it for global use.

I don't know how is The Right Way to do this, but it must be done so 
that `gdm' to work correctly in different languages.  Now I use a 
patched `/etc/init.d/gdm' with line `export LANG=bg_BG' added.

Regards
-- 
Ognyan Kulev <ogi@fmi.uni-sofia.bg>, "\"Programmer\""




Merged 133578 147091. Request was from Ognyan Kulev <ogi@fmi.uni-sofia.bg> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>, gdm@packages.qa.debian.org:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to Ognyan Kulev <ogi@fmi.uni-sofia.bg>:
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>, gdm@packages.qa.debian.org. Full text and rfc822 format available.

Message #12 received at 147091@bugs.debian.org (full text, mbox):

From: Ognyan Kulev <ogi@fmi.uni-sofia.bg>
To: 147091@bugs.debian.org
Subject: Patch
Date: Thu, 16 May 2002 00:39:18 +0300
[Message part 1 (text/plain, inline)]
Hi,

Here is a patch fix this bug by setting LANG in `/etc/init.d/gdm'.  In 
source package `gdm' this is file `debian/init'.

Regards
-- 
Ognyan Kulev <ogi@fmi.uni-sofia.bg>, "\"Programmer\""
[gdm.patch (text/plain, inline)]
--- init.orig	Wed May 15 22:18:49 2002
+++ init	Thu May 16 00:32:46 2002
@@ -20,6 +20,12 @@
 PIDFILE=/var/run/gdm.pid
 UPGRADEFILE=/var/run/gdm.upgrade
 
+# Setup the default LANG environment variable if there is such
+LANG_RE='^LANG=[a-z][-a-zA-Z0-9_.@]*$'
+if test -f /etc/environment && grep -q "$LANG_RE" /etc/environment; then
+	export `grep "$LANG_RE" /etc/environment`
+fi
+
 if [ -e $UPGRADEFILE -a "$1" != "restart" -a "$1" != "force-reload" ]; then
 	SSD_ARG="--startas $DAEMON"
 	rm -f $UPGRADEFILE

Tags added: patch Request was from Ognyan Kulev <ogi@fmi.uni-sofia.bg> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to Javier Fernández-Sanguino Peña <jfs@computer.org>:
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>. Full text and rfc822 format available.

Message #19 received at 147091@bugs.debian.org (full text, mbox):

From: Javier Fernández-Sanguino Peña <jfs@computer.org>
To: 147091@bugs.debian.org
Subject: Why is this bug still open?
Date: Mon, 21 Jul 2003 22:31:07 +0200
[Message part 1 (text/plain, inline)]
I find it ludicrous that a bug that is _so_ easy to fix (have gdm's init 
script read the /etc/environment definition) should be still open after 
being reported (with a patch) over a year ago.

Notice that _not_ setting gdm locale properly means that, whatever window
manager is run and whatever desktop is used (GNOME or KDE) might not launch
properly applications (i.e. with the locale environment setup for the user
who is running the gdm configuration file) even if the system administrator 
has defined them properly in /etc/environment.

Does policy need to explicitly say that generic system configuration (such 
as /etc/environment) needs to be sourced by every and all init.d scripts 
(including gdm) for this to be fixed? I wonder...

In any event, I would really appreciate if the maintainer of gdm turned 
around and fixed this stupid i18n bug which, in the long term, confuses 
end-users quite a lot and ends up them having (unless they do a second 
configuration of gdm's configuration file) a mixed environment (english and 
default locale) after setting up a system-wide locale definition with 
debconf.

Please fix this bug!

Javi
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to rmurray@cyberhqz.com (Ryan Murray):
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>. Full text and rfc822 format available.

Message #24 received at 147091@bugs.debian.org (full text, mbox):

From: rmurray@cyberhqz.com (Ryan Murray)
To: Javier Fern?ndez-Sanguino Pe?a <jfs@computer.org>, 147091@bugs.debian.org
Subject: Re: Bug#147091: Why is this bug still open?
Date: Tue, 22 Jul 2003 01:54:20 -0700
[Message part 1 (text/plain, inline)]
On Mon, Jul 21, 2003 at 10:31:07PM +0200, Javier Fern?ndez-Sanguino Pe?a wrote:
> who is running the gdm configuration file) even if the system administrator 
> has defined them properly in /etc/environment.

GDM has a menu to select the locale, and once a user has logged in, that's
what is used (that's when /etc/environment is read, or the user's menu
selection is used instead).

> Does policy need to explicitly say that generic system configuration (such 
> as /etc/environment) needs to be sourced by every and all init.d scripts 
> (including gdm) for this to be fixed? I wonder...

I think this is wrong.  /etc/environment is a PAM configuration file
that is read at login.  This makes it a poor choice as a "global
default LANG setting".  I agree that one is needed, I just don't think
it should be /etc/environment.  It should also be done once, early in
the boot sequence, so that as much of the boot sequence as possible
can be localized.

-- 
Ryan Murray, Debian Developer (rmurray@cyberhqz.com, rmurray@debian.org)
The opinions expressed here are my own.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to Javier Fernández-Sanguino Peña <jfs@computer.org>:
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>. Full text and rfc822 format available.

Message #29 received at 147091@bugs.debian.org (full text, mbox):

From: Javier Fernández-Sanguino Peña <jfs@computer.org>
To: Ryan Murray <rmurray@cyberhqz.com>
Cc: 147091@bugs.debian.org
Subject: Re: Bug#147091: Why is this bug still open?
Date: Wed, 23 Jul 2003 08:59:54 +0200
[Message part 1 (text/plain, inline)]
On Tue, Jul 22, 2003 at 01:54:20AM -0700, Ryan Murray wrote:
> On Mon, Jul 21, 2003 at 10:31:07PM +0200, Javier Fern?ndez-Sanguino Pe?a wrote:
> > who is running the gdm configuration file) even if the system administrator 
> > has defined them properly in /etc/environment.
> 
> GDM has a menu to select the locale, and once a user has logged in, that's
> what is used (that's when /etc/environment is read, or the user's menu
> selection is used instead).

Yes. I'm aware of this menu but it does not make much sense to me to ask 
the user again after the system admin has setup a sane default.

> 
> > Does policy need to explicitly say that generic system configuration (such 
> > as /etc/environment) needs to be sourced by every and all init.d scripts 
> > (including gdm) for this to be fixed? I wonder...
> 
> I think this is wrong.  /etc/environment is a PAM configuration file
> that is read at login.  This makes it a poor choice as a "global
> default LANG setting".  I agree that one is needed, I just don't think
> it should be /etc/environment. 

Then let's say we need an /etc/default/language file which defines which 
language environment and encoding needs to be used throughout all the 
different pieces that are using i18n/l10n. 

> It should also be done once, early in
> the boot sequence, so that as much of the boot sequence as possible
> can be localized.

What do you mean early in the boot sequence? Are you suggesting that the
init.d scripts run under a localised environment already? Maybe an
environment setup by init?

Regards

Javi
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to Daniel Ruoso <daniel@ruoso.com>:
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>. Full text and rfc822 format available.

Message #34 received at 147091@bugs.debian.org (full text, mbox):

From: Daniel Ruoso <daniel@ruoso.com>
To: 147091@bugs.debian.org
Subject: Please source /etc/environment inside /etc/init.d/gdm
Date: Thu, 21 Aug 2003 12:28:15 -0300
Hi,

I think this bug is really annoying (because I do use a localized system
and I don't like to maintain this patch in every machine I use).

At the beggining of this week I posted a message to debian devel about
this bug, and then yesterday (aug 20) I posted about this provisory
solution (at least until any definition is made) and nobody complained.

The only thing to do is to include in /etc/init.d/gdm
[ -f /etc/environment ] && . /etc/environment

Or the patch already submitted in this bug, which takes only the LANG
definition.

thanks in advance




Merged 133578 147091 192143. Request was from rmurray@cyberhqz.com (Ryan Murray) to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to Raphael Derosso Pereira <dephinit@csinetworks.com.br>:
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>. Full text and rfc822 format available.

Message #41 received at 147091@bugs.debian.org (full text, mbox):

From: Raphael Derosso Pereira <dephinit@csinetworks.com.br>
To: 147091@bugs.debian.org
Subject: Re: Please source /etc/environment inside /etc/init.d/gdm
Date: Thu, 04 Sep 2003 14:03:34 -0300
Hello,

The problem is that sourcing /etc/environment inside /etc/init.d/gdm is
not sufficient any more. I don't know why, but when I do this and logon,
I loose the environment again. It seems it should be sourced elsewhere,
like Xsession.

For example, I use ç in my language and GTK has a bug (or whatever you
want to call it) and need the environment variable GTK_IM_MODULE=xim to
be set. If I source /etc/environment in /etc/init.d/gdm, I can use ç in
GDM, but after the login process, I loose this environment and my ç
becomes ć...

This is A VERY IMPORTANT BUG, at least to International users. I didn't
find a solution yet... Please report...

-- 
Raphael Derosso Pereira
Consultor Técnico

CSI Networks
http://www.csinetworks.com.br





Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to "Steinar H. Gunderson" <sgunderson@bigfoot.com>:
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>. Full text and rfc822 format available.

Message #46 received at 147091@bugs.debian.org (full text, mbox):

From: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
To: 147091@bugs.debian.org
Subject: Re: Please source /etc/environment inside /etc/init.d/gdm
Date: Wed, 1 Oct 2003 21:45:25 +0200
> The problem is that sourcing /etc/environment inside /etc/init.d/gdm is
> not sufficient any more. I don't know why, but when I do this and logon,
> I loose the environment again. It seems it should be sourced elsewhere,
> like Xsession.

Adding

  auth       required   pam_env.so

to /etc/pam.d/gdm fixes this problem. I agree that as long as the locales
package sets stuff in /etc/environment, gdm should read its data from there,
if nothing else until a proper place for this exists in Debian.

/* Steinar */
-- 
Homepage: http://www.sesse.net/




Information forwarded to debian-bugs-dist@lists.debian.org, Ryan Murray <rmurray@debian.org>:
Bug#147091; Package gdm. Full text and rfc822 format available.

Acknowledgement sent to "Carlos A. Paramio" <carlosparamio@softlian.com>:
Extra info received and forwarded to list. Copy sent to Ryan Murray <rmurray@debian.org>. Full text and rfc822 format available.

Message #51 received at 147091@bugs.debian.org (full text, mbox):

From: "Carlos A. Paramio" <carlosparamio@softlian.com>
To: 147091@bugs.debian.org
Subject: It needs to export LANG variable
Date: Sun, 22 Feb 2004 18:03:05 +0100
[Message part 1 (text/plain, inline)]
Package: gdm
Version: 2.4.1.7-1

The patch isn't complete. It needs to export LANG variable. The first
time you test it without this patch it works because probably you're
restarting the service at console, and in this environment your LANG
variable is set to the correct value (and gdm uses it). But if init
process runs 'gdm', it needs to source and export LANG by himself.

Here's the complete patch for the gdm package. Please fix it.
[gdm-locales.patch (text/x-patch, attachment)]

Merged 133578 147091 192143 200064. Request was from rmurray@cyberhqz.com (Ryan Murray) to control@bugs.debian.org. Full text and rfc822 format available.

Tags removed: patch Request was from rmurray@cyberhqz.com (Ryan Murray) to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: pending Request was from Ryan Murray <rmurray@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Reply sent to Ryan Murray <rmurray@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Ognyan Kulev <ogi@fmi.uni-sofia.bg>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #62 received at 133578-close@bugs.debian.org (full text, mbox):

From: Ryan Murray <rmurray@debian.org>
To: 133578-close@bugs.debian.org
Subject: Bug#133578: fixed in gdm 2.4.4.7-2
Date: Sat, 15 May 2004 19:32:06 -0400
Source: gdm
Source-Version: 2.4.4.7-2

We believe that the bug you reported is fixed in the latest version of
gdm, which is due to be installed in the Debian FTP archive:

gdm_2.4.4.7-2.diff.gz
  to pool/main/g/gdm/gdm_2.4.4.7-2.diff.gz
gdm_2.4.4.7-2.dsc
  to pool/main/g/gdm/gdm_2.4.4.7-2.dsc
gdm_2.4.4.7-2_i386.deb
  to pool/main/g/gdm/gdm_2.4.4.7-2_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 133578@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Ryan Murray <rmurray@debian.org> (supplier of updated gdm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Sat, 15 May 2004 16:13:30 -0700
Source: gdm
Binary: gdm
Architecture: source i386
Version: 2.4.4.7-2
Distribution: unstable
Urgency: low
Maintainer: Ryan Murray <rmurray@debian.org>
Changed-By: Ryan Murray <rmurray@debian.org>
Description: 
 gdm        - GNOME Display Manager
Closes: 133578 189615 200121 201303 240984 240993 243218 247065 247971 248328
Changes: 
 gdm (2.4.4.7-2) unstable; urgency=low
 .
   * Correct location of logdir (closes: #240984)
   * Add /etc/default/gdm, initialized from the locales package's debconf.
     (closes: #133578)
   * Add depends on xbase-clients until #242485 is fixed in X. (closes: #247065)
   * Change "genius" to "gdm" in default config comments (closes: #243218)
   * Soft restart gdm in postinst (closes: #240993)
   * Update locale.conf to latest glibc (closes: #247971)
   * Create .dmrc with restrictive permissions if it doesn't exist.
   * Now that gksu works for me, use it to start gdmsetup (closes: #189615)
   * Update debconf templates to xdm 4.3.0.dfsg.1-1.
   * Add Turkish debconf template (closes: #248328)
   * Add note about debconf templates to README.Debian (closes: #200121)
   * Add some whitespace to the gdmlogin logo (closes: #201303)
   * Build with SELinux support.
Files: 
 1381463e18b269eb2923b3cacea9ae36 679 gnome optional gdm_2.4.4.7-2.dsc
 caa7d5c889309d6f5513130974745829 199919 gnome optional gdm_2.4.4.7-2.diff.gz
 df6a4fb94166bdaa16769841df69a990 2059872 gnome optional gdm_2.4.4.7-2_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.4 (GNU/Linux)

iD8DBQFApqbGN2Dbz/1mRasRAvatAJ9uPfbZdqrHo+oAtgiC+pn7CuJJXACgszKF
w0uABgBxaEmRSqgh9fbt3HE=
=M2zR
-----END PGP SIGNATURE-----




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 01:55:58 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.